/****************************************************************************
 File name:  CS460_PthreadsSimple.c
 Author:     $Author$
 Date:       March 7, 2012
 Class:      CS460
 Assignment:
 Purpose:
 RevisionID:  $Id$
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>

#define MAX_TIDS 128

// global shared data
double global = 0.0;
int gThreadExecutionCouter[MAX_TIDS];


/****************************************************************************
Function: 		runner

Description: 	The function run during thread invocation.
							update the global value by 0.1 100 times.

Parameters: 	void* -  a pointer to an integer representing the user generated
							Thread ID.

Returned: 		NULL
****************************************************************************/
void* runner(void* param)
{
	int tid = *(int*) param;
	int i;

	for(i=0 ; i < 100 ; i++)
	{

		//update the global counter
		global += .1;
		fprintf(stderr,"[%d] I have the mutex! %f\n",tid, global);

		//track how many times each thread updates the global variable
		gThreadExecutionCouter[tid] ++;
	}

	return NULL;
}

/****************************************************************************
Function: 		main

Description: 	Launch a large number of threads, wait on each Thread and
							display the calculated sum as well as how many times each
							thread updated the global sum.
Parameters: 	none

Returned: 		int - 0 if success, -1 if failure
****************************************************************************/
int main()
{
	int i = 0;
	int numbThreads = MAX_TIDS	;
	int *pThreadId;

	pthread_attr_t attr;
	pthread_t tids[MAX_TIDS];

	pthread_attr_init(&attr);

	/* create the threads */
	for(i=0; i<numbThreads; i++)
	{
		pThreadId = (int*) malloc(sizeof(int));
		*pThreadId = i;
		gThreadExecutionCouter[*pThreadId] = 0;
		pthread_create(&(tids[i]), &attr, runner, pThreadId);
	}

	/* now wait for the threads to exit */
	for(i=0; i<numbThreads; i++)
	{
		pthread_join(tids[i], NULL);
	}

	printf("Global: %f\n\n", global);

	for(i=0; i < numbThreads; i++)
	{
		printf("[%3d]:%3d\t", i,gThreadExecutionCouter[i]);
		if( (i+1) % 10 == 0)
		{
			printf("\n");
		}
	}

	pthread_attr_destroy(&attr);

	return EXIT_SUCCESS;
}
